#include <stdio.h>

#define N 80
#define RADIX 10000

int
main(int argc, char *argv[])
{
	unsigned x[N] = { 0 };
	int i, j, k, hi, lo, above;

	for (k = 0; k < N; k++) {
		hi = RADIX;
		lo = 0;

		while (hi - lo > 1) {
			unsigned t[2*N] = { 0 }, r;

			x[k] = (hi + lo) / 2;

			for (i = k; i >= 0; i--)
				for (j = k; j >= 0; j--)
					t[j + i + 1] += x[i]*x[j];

			for (r = 0, i = 2*(k + 1) - 1; i >= 0; i--) {
				r = t[i] + r;
				t[i] = r%RADIX;
				r /= RADIX;
			}

			above = 0;

			if (t[0] || (t[1] - 1 > x[0])) {
				above = 1;
			} else if (t[1] - 1 == x[0]) {
				for (i = 1; i <= k + 1; i++) {
					if (t[i + 1] > x[i]) {
						above = 1;
						break;
					}

					if (t[i + 1] < x[i])
						break;
				}
			}

			*(above ? &hi : &lo) = x[k];
		}

		printf(k ? "%04d" : "%d.", x[k] = lo);
	}

	return 0;
}

