
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main (int argc, char **argv) {

	double pi = 0;
	long pi_tmp = 0;
	double x, y;
	long n = 0;
	long n_max = 10e7;

	if (argc == 2) {
		n_max = atoi(argv[1]);
	}
	printf("PI from Monte Carlo\nsyntax: %s [N] (def: 10e7)\n", argv[0]);

	// pi = integral [-1,1][-1,1] f(x,y)dxdy
	// pi = [(1 - (-1)) + (1 - (-1))] / N * sum (p(x,y))
	// p(x,y) = 1 if (x + y) <= 1 (in the circle)
	// p(x,y) = 0 otherwise
	// thus, pi = 4/N sum[p(x,y)]
	//  -> if x and y are sufficiently random
	//  -> if N is suficiently large
	while (n < n_max) { // variation is high
		// choose random pair
		x = random();
		y = random();
		x = ((x*2) / RAND_MAX) - 1;
		y = ((y*2) / RAND_MAX) - 1;

		// if inside the circle
		if ((x*x + y*y) <= 1) {
			pi_tmp += 1;
		}

		// debug
		if (!(n%10000))
			printf("\r%.02lf%%", ((double)(n/(double)n_max))*100);

		n++;
	}
	// pi = 4/N * sum()
	pi = ((double)pi_tmp * 4) / n;

	printf ("\n\nPI by math.h: %lf and PI by this code: %lf\n", M_PI, pi);
	return 0;
}
